# coding: utf-8
"""
    Snowflake Role API.

    The Snowflake Role API is a REST API that you can use to access, update, and perform certain actions on Role resource in a Snowflake database.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from datetime import datetime

from pydantic import BaseModel, ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class GrantOf(BaseModel):
    """A model object representing the GrantOf resource.

    Constructs an object of type GrantOf with the provided properties.

    Parameters
    __________
    role : str, optional
        The name of the role
    granted_to : str, optional
        The type of the grantee, can be USER or ROLE
    grantee_name : str, optional
        The name of the grantee
    granted_by : str, optional
        The role that granted this role to this grantee
    created_on : datetime, optional
        Date and time when the grant was created
    """

    role: Optional[StrictStr] = None

    granted_to: Optional[StrictStr] = None

    grantee_name: Optional[StrictStr] = None

    granted_by: Optional[StrictStr] = None

    created_on: Optional[datetime] = None

    __properties = [
        "role", "granted_to", "grantee_name", "granted_by", "created_on"
    ]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> GrantOf:
        """Create an instance of GrantOf from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias."""
        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude={
                           "role",
                           "granted_to",
                           "grantee_name",
                           "granted_by",
                           "created_on",
                       },
                       exclude_none=True))

        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> GrantOf:
        """Create an instance of GrantOf from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return GrantOf.parse_obj(obj)

        _obj = GrantOf.parse_obj({
            "role": obj.get("role"),
            "granted_to": obj.get("granted_to"),
            "grantee_name": obj.get("grantee_name"),
            "granted_by": obj.get("granted_by"),
            "created_on": obj.get("created_on"),
        })

        return _obj


from typing import Optional, List, Dict


class GrantOfModel():

    def __init__(
        self,  # optional properties
        role: Optional[str] = None,
        granted_to: Optional[str] = None,
        grantee_name: Optional[str] = None,
        granted_by: Optional[str] = None,
        created_on: Optional[datetime] = None,
    ):
        """A model object representing the GrantOf resource.

        Constructs an object of type GrantOf with the provided properties.

        Parameters
        __________
        role : str, optional
            The name of the role
        granted_to : str, optional
            The type of the grantee, can be USER or ROLE
        grantee_name : str, optional
            The name of the grantee
        granted_by : str, optional
            The role that granted this role to this grantee
        created_on : datetime, optional
            Date and time when the grant was created
        """

        self.role = role
        self.granted_to = granted_to
        self.grantee_name = grantee_name
        self.granted_by = granted_by
        self.created_on = created_on

    __properties = [
        "role", "granted_to", "grantee_name", "granted_by", "created_on"
    ]

    def _to_model(self):
        return GrantOf(
            role=self.role,
            granted_to=self.granted_to,
            grantee_name=self.grantee_name,
            granted_by=self.granted_by,
            created_on=self.created_on,
        )

    @classmethod
    def _from_model(cls, model) -> GrantOfModel:
        return GrantOfModel(
            role=model.role,
            granted_to=model.granted_to,
            grantee_name=model.grantee_name,
            granted_by=model.granted_by,
            created_on=model.created_on,
        )

    def to_dict(self):
        """Creates a dictionary of the properties from a GrantOf.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the GrantOf object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> GrantOfModel:
        """Creates an instance of GrantOf from a dict.

        This method constructs a GrantOf object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        GrantOf
            A GrantOf object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(GrantOf.from_dict(obj))


GrantOf._model_class = GrantOfModel
